let viewer;

window.onload = () => {
  const element = document.getElementById('canvas');

  viewer = new SkinViewer({
    canvas: element,
    width: 300,
    height: 400,
    skin: './steve_simple.png',
    enableControls: true,
  });

  window.viewer = viewer;

  window.addEventListener('dataReceived', () => {
    const webViewData = window.receivedData;
    if (webViewData && webViewData.message.img) {
      const base64Data = webViewData.message.img;
      const byteCharacters = atob(base64Data);
      const byteNumbers = new Array(byteCharacters.length).fill(0).map((_, i) => byteCharacters.charCodeAt(i));
      const byteArray = new Uint8Array(byteNumbers);
      const blob = new Blob([byteArray], { type: 'image/png' });

      const blobUrl = URL.createObjectURL(blob);
      try {
        viewer.loadSkin(blobUrl);
      } catch (error) {
        console.error('Error loading skin', error);
      }

      URL.revokeObjectURL(blobUrl);
    }
    /*if (webViewData && webViewData.message.skinName) {
      const skinNameDiv = document.getElementById('skin-name');
      skinNameDiv.textContent = `${webViewData.message.skinName}`;
    }*/
  });

  window.addEventListener('skinpreview', () => {
    if (window.receivedData && window.receivedData?.message?.skinName && window.receivedData?.message?.skin) {
      /*const skinNameDiv = document.getElementById('skin-name');
      skinNameDiv.textContent = `${window.receivedData?.message?.skinName}`;*/

      const base64Data = window.receivedData?.message?.skin;
      const byteCharacters = atob(base64Data);
      const byteNumbers = new Array(byteCharacters.length).fill(0).map((_, i) => byteCharacters.charCodeAt(i));
      const byteArray = new Uint8Array(byteNumbers);
      const blob = new Blob([byteArray], { type: 'image/png' });

      const blobUrl = URL.createObjectURL(blob);

      try {
        viewer.height = 150;
        viewer.width = 150;
        viewer.loadSkin(blobUrl);
      } catch (error) {
        console.error('Error loading skin', error);
      }
    }
  });

  // tell app we are ready 
  window.ReactNativeWebView.postMessage('WebViewReady');
};
